function [f,g,Jfx,Jgx,Jfp,Jgp] = Elowitz2000_6states( varargin )
    additionalArgs = {};

    if nargin<1
        f = [0;0;0;0;20;0];
        g = [20;2;40;2;10;0.5;0.0005;1];
        return
    elseif nargin==2 
        time = varargin{1};
        x = varargin{2};
        p = [20;2;40;2;10;0.5;0.0005;1];
    else
        time = varargin{1};
        x = varargin{2};
        p = varargin{3};
        if nargin > 3
            additionalArgs = varargin(4:end);
        end
    end 

    f = [(0.69314718055994528622676398299518*p(1)*x(4))/(p(4)*p(8)) - (0.69314718055994528622676398299518*x(1))/(p(5)*p(8));
		(0.69314718055994528622676398299518*p(1)*x(5))/(p(4)*p(8)) - (0.69314718055994528622676398299518*x(2))/(p(5)*p(8));
		(0.69314718055994528622676398299518*p(1)*x(6))/(p(4)*p(8)) - (0.69314718055994528622676398299518*x(3))/(p(5)*p(8));
		60.0*p(7) + (p(3)^p(2)*(60.0*p(6) - 60.0*p(7)))/(p(3)^p(2) + (x(3)/p(8))^p(2)) - (0.69314718055994528622676398299518*x(4))/(p(4)*p(8));
		60.0*p(7) + (p(3)^p(2)*(60.0*p(6) - 60.0*p(7)))/(p(3)^p(2) + (x(1)/p(8))^p(2)) - (0.69314718055994528622676398299518*x(5))/(p(4)*p(8));
		60.0*p(7) + (p(3)^p(2)*(60.0*p(6) - 60.0*p(7)))/(p(3)^p(2) + (x(2)/p(8))^p(2)) - (0.69314718055994528622676398299518*x(6))/(p(4)*p(8))];

    if nargout<2 
        return
    end

    g = [(0.69314718055994528622676398299518*f(4)*p(1))/(p(4)*p(8)) - (0.69314718055994528622676398299518*f(1))/(p(5)*p(8));
		(0.69314718055994528622676398299518*f(5)*p(1))/(p(4)*p(8)) - (0.69314718055994528622676398299518*f(2))/(p(5)*p(8));
		(0.69314718055994528622676398299518*f(6)*p(1))/(p(4)*p(8)) - (0.69314718055994528622676398299518*f(3))/(p(5)*p(8));
		- (0.69314718055994528622676398299518*f(4))/(p(4)*p(8)) - (1.0*f(3)*p(2)*p(3)^p(2)*(x(3)/p(8))^(p(2) - 1.0)*(60.0*p(6) - 60.0*p(7)))/(p(8)*(p(3)^p(2) + (x(3)/p(8))^p(2))^2);
		- (0.69314718055994528622676398299518*f(5))/(p(4)*p(8)) - (1.0*f(1)*p(2)*p(3)^p(2)*(x(1)/p(8))^(p(2) - 1.0)*(60.0*p(6) - 60.0*p(7)))/(p(8)*(p(3)^p(2) + (x(1)/p(8))^p(2))^2);
		- (0.69314718055994528622676398299518*f(6))/(p(4)*p(8)) - (1.0*f(2)*p(2)*p(3)^p(2)*(x(2)/p(8))^(p(2) - 1.0)*(60.0*p(6) - 60.0*p(7)))/(p(8)*(p(3)^p(2) + (x(2)/p(8))^p(2))^2)];

    if nargout<3 
         return 
    elseif nargout==3 
         [Jfx] = jac_Elowitz2000_6states(time, x, f, p, additionalArgs{:});
    elseif nargout==4 
         [Jfx,Jgx] = jac_Elowitz2000_6states(time, x, f, p, additionalArgs{:});
    elseif nargout==5 
          [Jfx,Jgx,Jfp] = jac_Elowitz2000_6states(time, x, f, p, additionalArgs{:});
    elseif nargout==6 
          [Jfx,Jgx,Jfp,Jgp] = jac_Elowitz2000_6states(time, x, f, p, additionalArgs{:});
    elseif nargout>6 
         error('Too many output arguments');
    end
end
